<?php
/**
 * ShopEx licence
 *
 * @copyright  Copyright (c) 2005-2012 ShopEx Technologies Inc. (http://www.shopex.cn)
 * @license  http://ecos.shopex.cn/ ShopEx License
 * @author afei, bryant
 */


class system_ctl_admin_queue extends desktop_controller {

    var $workground = 'system.workground.setting';
    function index() {
        $params = array (
            'title' => app::get('system')->_('队列管理'),
        );

        $queue_controller_name = system_queue::get_driver_name();
        $support_queue_controller_name = 'system_queue_adapter_mysql';

        if ($queue_controller_name == $support_queue_controller_name)
        {
            return $this->finder('system_mdl_queue_mysql', $params);
        }
        else
        {
            if( $queue_controller_name == 'system_queue_adapter_redis' )
            {
                $pagedata = $this->__getRedisQueue();
                $pagedata['type'] = $_GET['type'];
                return $this->page('system/admin/queue/redis.html', $pagedata);
            }
            else
            {
                $pagedata['queue_controller_name'] = $queue_controller_name;
                $pagedata['support_queue_controller_name'] = $support_queue_controller_name;
                return $this->page('system/admin/queue.html', $pagedata);
            }
        }
    }

    private function __getRedisQueue()
    {
        $queueList = config::get('queue.queues');

        $objectReids = redis::scene('queue');
        $total = [];
        $waitTotal = 0;
        $reservedTotal = 0;
        $failedTotal = 0;

        $RedisQueue = kernel::single('system_queue_adapter_redis');
        //默认执行队列的有效时间
        $expire = $RedisQueue->getExpire();
        $pages = $_GET['pages'];
        foreach( $queueList as $queueName => $row )
        {
            $waitLen = $objectReids->llen($queueName);
            $queueList[$queueName]['wait']['len'] = $waitLen;
            $waitTotal += $waitLen;
            $waitData = $objectReids->lrange($queueName,0,-1);

            if( $waitData )
            {
                $waitQueueData = $waitQueueData ? array_merge($waitQueueData, $waitData) : $waitData;
            }

            $failedLen = $objectReids->zcount($queueName.":reserved", '-inf', time());
            $queueList[$queueName]['failed']['len'] = $failedLen;
            $failedTotal += $failedLen;
            $failedData = $objectReids->zrangebyscore($queueName.":reserved",'-inf',time());
            if( $failedData )
            {
                $failedQueueData = $failedQueueData ? array_merge($failedQueueData, $failedData) : $failedData;
            }
        }


        foreach( $waitQueueData as $key=>&$row )
        {
            $row = json_decode($row, 1);
        }

        foreach( $failedQueueData as $key=>&$row )
        {
            $row = json_decode($row, 1);
        }

        $total['wait'] = $waitTotal;
        $total['failed'] = $failedTotal;
        $queueData['wait'] = $waitQueueData;
        $queueData['failed'] = $failedQueueData;
        return ['queuelist'=>$queueList, 'total'=>$total, 'queueData'=>$queueData];
    }

    //查看指定队列数据
    public function showRedisQueueParams($params, $id)
    {
        $pagedata['id']= $id;
        $pagedata['params']= urldecode($params);
        return view::make('system/admin/queue/redisParams.html', $pagedata);
    }

    public function delRedisQueue($queueType, $value)
    {
        $this->begin('?app=system&ctl=admin_queue&act=index&type='.$queueType);
        $value = urldecode($value);

        $objectReids = redis::scene('queue');
        if( $queueType == 'wait' )
        {
            $queueName = json_decode($value,1)['queue_name'];
            $result = $objectReids->lrem($queueName ,1,$value);
        }
        else
        {
            $queueName = json_decode($value,1)['queue_name'].":reserved";
            $result = $objectReids->zrem($queueName ,1,$value);
        }

        $this->end(true, app::get('system')->_('操作成功'));
    }
}
